<!--
 * @Author: zhp
 * @Date: 2023-02-14 15:02:26
 * @LastEditTime: 2023-07-12 13:55:20
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-form :model="dataForm" ref="dataForm" :rules="dataRule" @keyup.enter.native="dataFormSubmitHandle()"
    label-width="120px">
    <el-form-item prop="customerTypeCode" :label="$t('basic.code')">
      <el-input v-model="dataForm.customerTypeCode" :placeholder="$t('basic.code')"></el-input>
    </el-form-item>
    <el-form-item prop="customerTypeName" :label="$t('basic.name')">
      <el-input v-model="dataForm.customerTypeName" :placeholder="$t('basic.name')"></el-input>
    </el-form-item>
    <el-form-item prop="customerTypeStatus" :label="$t('basic.status')">
      <el-select v-model="dataForm.customerTypeStatus" :placeholder="$t('basic.status')">
        <el-option v-for="item in options" :key="item.value" :label="item.label" :value="item.value">
        </el-option>
      </el-select>
    </el-form-item>
  </el-form>
</template>

<script>
import debounce from "lodash/debounce";
import basicAdd from "@/mixins/basic-add";
export default {
  mixins: [basicAdd],
  data() {
    return {
      urlOptions: {
        submitURL: "/basic/qmsCustomerType",
        infoURL: "/basic/qmsCustomerType/{id}",
        getCodeURL: '/basic/qmsCustomerType/getCode'
      },
      options: [{
        value: 0,
        label: '不可用'
      },
      {
        value: 1,
        label: '可用'
      }],
      visible: false,
      dataForm: {
        id: "",
        customerTypeCode:null,
        customerTypeName:null,
        customerTypeStatus:null
      },
    };
  },
  computed: {
    dataRule() {
      return {
        customerTypeCode: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        customerTypeName: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        customerTypeStatus: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "change",
          },
        ],
      };
    },
  },
  methods: {
    init(id,) {
      this.dataForm.id = id || "";
      // this.dataForm.dictTypeId = dictTypeId || "";
      this.visible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.dataForm.id) {
          this.getInfo();
        } else {
          this.getCode()
        }
      });
    },
    getCode() {
      // console.log(111111);
      this.$http
        .post(this.urlOptions.getCodeURL)
        .then(({ data: res }) => {
          if (res.code === 0) {
            console.log(res);
            this.dataForm.customerTypeCode = res.data
          }
        })
        .catch(() => {
        });
    },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/basic/qmsCustomerType/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => {});
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](this.urlOptions.submitURL, this.dataForm)
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  this.visible = false;
                  console.log(1111);
                  this.$emit("successSubmit");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
